import { ChatInputCommandInteraction, Message, PermissionFlagsBits, SlashCommandBuilder } from 'discord.js';
import EcoController from '../controller/EcoController';
import { Pagination } from "pagination.djs"
import { Command } from '.';

// const { Pagination } = require('pagination.djs');

// const adminPermissions = new PermissionsBitField('Administrator');

export default {
  data: new SlashCommandBuilder()
    .setName('exec')
    .setDescription('Exec command')
    .addStringOption(opt => opt.setName("command").setDescription("Command").setRequired(true))
    .setDefaultMemberPermissions(PermissionFlagsBits.Administrator),
  async execute(interaction) {
    const i: ChatInputCommandInteraction<"cached"> = interaction as any

    const ecoController = new EcoController()

    const command = i.options.getString('command')

    await i.deferReply({ ephemeral: true })

    try {
      if (!command) {
        await interaction.followUp(`Ошибка выполнения команды.`);
        return
      }

      const status = await ecoController.Exec(command)

      const pagination = new Pagination(i)
      pagination.setLimit(20)

      if (!!status && !status.Errored) {
        if (status.CommandMessages.filter(e => e.Type === "Notifications-Chat").length > 0) {
          if (status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.length <= 2000)
            await i.followUp(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.substring(0, 2000) || "Команда выполнена")
          else {
            pagination.setDescriptions(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.split("\n"))
            pagination.render();
          }
        } else
          await interaction.followUp(JSON.stringify(status).substring(0, 2000))
      } else {
        if (!!status && status.CommandMessages.filter(e => e.Type === "Notifications-Chat").length > 0)
          if (status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.length <= 2000)
            await i.followUp(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.substring(0, 2000) || "Команда выполнена")
          else {
            pagination.setDescriptions(status.CommandMessages.filter(e => e.Type === "Notifications-Chat")[0].Message.split("\n"))
            pagination.render();
          }
        else
          await interaction.followUp(JSON.stringify(status).substring(0, 2000))
      }
      return
    } catch (error) {
      await interaction.followUp("Ошибка выполнения команды. 1")
      console.log(error)
    }
  },
} as Command
